# I3DRenderingModule Struct Reference
[External Interfaces]

Inheritance diagram for I3DRenderingModule:

List of all members.

## Public Member Functions
virtual MCCOMErr MCCOMAPI | RenderOneFrame (I3DRenderingCallbacks *callbacks, boolean synch, int32 synchThreadID, uint32 width, uint32 height, RenderFilterNeeds &gbufferNeeds, I3DShCamera *camera=NULL)=0
virtual MCCOMErr MCCOMAPI | GetRenderHelper (I3DRenderHelper **renderHelper)=0
virtual MCCOMErr MCCOMAPI | Abort ()=0
virtual void MCCOMAPI | AbortAndWait ()=0
virtual MCCOMErr MCCOMAPI | GetRasterLayer (IShRasterLayer **rasterLayer)=0
virtual MCCOMErr MCCOMAPI | GetGBuffers (TMCCountedPtrArray< IShChannel > &gBuffers)=0
virtual MCCOMErr MCCOMAPI | GetSize (real &width, real &height, real &dpi)=0
virtual MCCOMErr MCCOMAPI | SetSize (real width, real height, real dpi)=0
virtual MCCOMErr MCCOMAPI | GetPixelSize (uint32 &width, uint32 &height)=0
virtual MCCOMErr MCCOMAPI | SetPixelSize (uint32 width, uint32 height)=0
virtual boolean MCCOMAPI | GetKeepProportions ()=0
virtual void MCCOMAPI | SetKeepProportions (boolean keepProportions)=0
virtual real MCCOMAPI | GetPixelAspectRatio ()=0
virtual void MCCOMAPI | SetPixelAspectRatio (real pixelAspectRatio)=0
virtual void MCCOMAPI | GetRenderingCamera (I3DShCamera **camera)=0
virtual void MCCOMAPI | SetRenderingCamera (I3DShCamera *camera)=0
virtual void MCCOMAPI | GetRenderingCameraByName (TMCString &cameraName)=0
virtual void MCCOMAPI | SetRenderingCameraByName (const TMCString &cameraName)=0
virtual int32 MCCOMAPI | GetFieldRendering ()=0
virtual void MCCOMAPI | SetFieldRendering (int32 fieldRendering)=0
virtual void MCCOMAPI | GetRenderer (I3DExFinalRenderer **renderer)=0
virtual MCCOMErr MCCOMAPI | SetRenderer (I3DExFinalRenderer *renderer)=0
virtual int32 MCCOMAPI | GetOutputOption ()=0
virtual MCCOMErr MCCOMAPI | SetOutputOption (int32 option)=0
virtual void MCCOMAPI | GetOutputFileName (TMCString &fileName)=0
virtual MCCOMErr MCCOMAPI | SetOutputFileName (const TMCString &fileName)=0
virtual IDType MCCOMAPI | GetImageFileTypeID ()=0
virtual MCCOMErr MCCOMAPI | SetImageFileTypeID (IDType fileTypeID)=0
virtual boolean MCCOMAPI | GetRenderMovie ()=0
virtual void MCCOMAPI | SetRenderMovie (boolean renderMovie)=0
virtual IDType MCCOMAPI | GetMovieFileTypeID ()=0
virtual MCCOMErr MCCOMAPI | SetMovieFileTypeID (IDType fileTypeID)=0
virtual MicroTick MCCOMAPI | GetBeginTime ()=0
virtual void MCCOMAPI | SetBeginTime (MicroTick beginTime)=0
virtual MicroTick MCCOMAPI | GetEndTime ()=0
virtual void MCCOMAPI | SetEndTime (MicroTick endTime)=0
virtual real32 MCCOMAPI | GetFramesPerSecond ()=0
virtual void MCCOMAPI | SetFramesPerSecond (real32 fps)=0
virtual boolean MCCOMAPI | GetAutoSwitchToMovie ()=0
virtual void MCCOMAPI | SetAutoSwitchToMovie (boolean autoSwitch)=0
virtual boolean MCCOMAPI | IsRendering ()=0
virtual void MCCOMAPI | GetAlphaSettings (boolean &useAlphaChannel, boolean &usePremultipliedAlpha)=0
virtual void MCCOMAPI | SetAlphaSettings (boolean useAlphaChannel, boolean usePremultipliedAlpha)=0

## Detailed Description

This is the interface of the rendering module. The is a rendering module attached to each scene document. It controls the rendering properties of the scene.

## Member Function Documentation

virtual MCCOMErr MCCOMAPI I3DRenderingModule::Abort | ( |  | ) | `[pure virtual]`

Kills any on going rendering.

virtual void MCCOMAPI I3DRenderingModule::AbortAndWait | ( |  | ) | `[pure virtual]`

Kills any on going rendering and waits for it to finish.

virtual void MCCOMAPI I3DRenderingModule::GetAlphaSettings | ( | boolean & | useAlphaChannel,
|  | boolean & | usePremultipliedAlpha |
| ) |  |  | `[pure virtual]`

Returns the current settings for alpha channel rendering.

Parameters:

  | useAlphaChannel | true if the alpha channel should be filled
  | usePremultipliedAlpha | true if the pre multiplied should be used

virtual boolean MCCOMAPI I3DRenderingModule::GetAutoSwitchToMovie | ( |  | ) | `[pure virtual]`

Returns true if the application automatically switch to movie when the time is changed.

virtual MicroTick MCCOMAPI I3DRenderingModule::GetBeginTime | ( |  | ) | `[pure virtual]`

Returns the time of the beginning of the rendering of a movie.

virtual MicroTick MCCOMAPI I3DRenderingModule::GetEndTime | ( |  | ) | `[pure virtual]`

Returns the time of the end of the rendering of a movie.

virtual int32 MCCOMAPI I3DRenderingModule::GetFieldRendering | ( |  | ) | `[pure virtual]`

Returns the Field Rendering Settings.

virtual real32 MCCOMAPI I3DRenderingModule::GetFramesPerSecond | ( |  | ) | `[pure virtual]`

Returns the frame rate.

virtual MCCOMErr MCCOMAPI I3DRenderingModule::GetGBuffers | ( | TMCCountedPtrArray< IShChannel > & | gBuffers | ) | `[pure virtual]`

Returns an array of pointers to the GBuffers. It is recommended to use I3DRenderHelper::GetGBuffers() instead.

Parameters:

  | gBuffers | The array of the GBuffers.

virtual IDType MCCOMAPI I3DRenderingModule::GetImageFileTypeID | ( |  | ) | `[pure virtual]`

Returns the file format of the rendered image.

virtual boolean MCCOMAPI I3DRenderingModule::GetKeepProportions | ( |  | ) | `[pure virtual]`

Returns true if the "Keep Proportions" checkbox is checked.

virtual IDType MCCOMAPI I3DRenderingModule::GetMovieFileTypeID | ( |  | ) | `[pure virtual]`

Returns the file format of the movie that is rendered.

virtual void MCCOMAPI I3DRenderingModule::GetOutputFileName | ( | TMCString & | fileName | ) | `[pure virtual]`

Returns The pathname of the output image file.

Parameters:

  | fileName | The pathname of the output image file.

virtual int32 MCCOMAPI I3DRenderingModule::GetOutputOption | ( |  | ) | `[pure virtual]`

Returns the output status:

- 1 save in default location.
- 2 save as specified by SetOutputFileName.

virtual real MCCOMAPI I3DRenderingModule::GetPixelAspectRatio | ( |  | ) | `[pure virtual]`

Returns the pixel aspect ration.

virtual MCCOMErr MCCOMAPI I3DRenderingModule::GetPixelSize | ( | uint32 & | width,
|  | uint32 & | height |
| ) |  |  | `[pure virtual]`

Returns the size of the rendered image in pixels.

Parameters:

  | width | Width of the image in pixels.
  | height | Height of the image in pixels.

virtual MCCOMErr MCCOMAPI I3DRenderingModule::GetRasterLayer | ( | IShRasterLayer ** | rasterLayer | ) | `[pure virtual]`

Returns a pointer to the raster layer containing the rendered data. A valid pointer will be returned only when called during the rendering. It is recommended to use I3DRenderHelper::GetRasterLayer() instead.

Parameters:

  | rasterLayer | A pointer to the raster Layer.

virtual void MCCOMAPI I3DRenderingModule::GetRenderer | ( | I3DExFinalRenderer ** | renderer | ) | `[pure virtual]`

Returns a pointer to the current final renderer.

Parameters:

  | renderer | A pointer to the current final renderer.

virtual MCCOMErr MCCOMAPI I3DRenderingModule::GetRenderHelper | ( | I3DRenderHelper ** | renderHelper | ) | `[pure virtual]`

Returns the current renderHelper after initializing it with the current scene and rendering settings.

This function should not be called when a rendering is in progress!

Parameters:

  | renderHelper | A pointer to the renderHelper that is returned.

virtual void MCCOMAPI I3DRenderingModule::GetRenderingCamera | ( | I3DShCamera ** | camera | ) | `[pure virtual]`

Returns the rendering camera.

Parameters:

  | camera | A pointer to the rendering camera.

virtual void MCCOMAPI I3DRenderingModule::GetRenderingCameraByName | ( | TMCString & | cameraName | ) | `[pure virtual]`

Returns the name of the rendering camera.

Parameters:

  | cameraName | The name of the rendering camera.

virtual boolean MCCOMAPI I3DRenderingModule::GetRenderMovie | ( |  | ) | `[pure virtual]`

Returns true if the render should render a movie (by opposition to the current frame).

virtual MCCOMErr MCCOMAPI I3DRenderingModule::GetSize | ( | real & | width,
|  | real & | height,
|  | real & | dpi |
| ) |  |  | `[pure virtual]`

Returns the size of the rendering. To calculate the size in pixels, use the following code:

     pixelH = width * dpi / 72;
     pixelV = height * dpi / 72;

Parameters:

  | width | Width of the image.
  | height | Height of the image.
  | dpi | Pixels per inch.

virtual boolean MCCOMAPI I3DRenderingModule::IsRendering | ( |  | ) | `[pure virtual]`

Returns true if a rendering is in progress

virtual MCCOMErr MCCOMAPI I3DRenderingModule::RenderOneFrame | ( | I3DRenderingCallbacks * | callbacks,
|  | boolean | synch,
|  | int32 | synchThreadID,
|  | uint32 | width,
|  | uint32 | height,
|  | RenderFilterNeeds & | gbufferNeeds,
|  | I3DShCamera * | camera = `NULL` |
| ) |  |  | `[pure virtual]`

Deprecated:
  You should use I3DRenderHelper::RenderArea() instead.

See also:
  GetRenderHelper

virtual void MCCOMAPI I3DRenderingModule::SetAlphaSettings | ( | boolean | useAlphaChannel,
|  | boolean | usePremultipliedAlpha |
| ) |  |  | `[pure virtual]`

Specifies the current settings for alpha channel rendering.

Parameters:

  | useAlphaChannel | true if the alpha channel should be filled
  | usePremultipliedAlpha | true if the pre-multiplied should be used

virtual void MCCOMAPI I3DRenderingModule::SetAutoSwitchToMovie | ( | boolean | autoSwitch | ) | `[pure virtual]`

Sets whether the application automatically switch to movie when the time is changed.

virtual void MCCOMAPI I3DRenderingModule::SetBeginTime | ( | MicroTick | beginTime | ) | `[pure virtual]`

Sets the time of the beginning of the rendering of a movie.

Parameters:

  | beginTime | The time of the beginning of the rendering of a movie.

virtual void MCCOMAPI I3DRenderingModule::SetEndTime | ( | MicroTick | endTime | ) | `[pure virtual]`

Sets the time of the end of the rendering of a movie.

Parameters:

  | endTime | The time of the end of the rendering of a movie.

virtual void MCCOMAPI I3DRenderingModule::SetFieldRendering | ( | int32 | fieldRendering | ) | `[pure virtual]`

Sets the Field Rendering Settings.

Parameters:

  | fieldRendering | 0 means no field rendering, 1 means odd dominance, 2 means even dominance.

virtual void MCCOMAPI I3DRenderingModule::SetFramesPerSecond | ( | real32 | fps | ) | `[pure virtual]`

Sets the frame rate.

Parameters:

  | fps | the frame rate.

virtual MCCOMErr MCCOMAPI I3DRenderingModule::SetImageFileTypeID | ( | IDType | fileTypeID | ) | `[pure virtual]`

Sets the file format of the rendered image.

Parameters:

  | fileTypeID | The file format of the rendered image.

virtual void MCCOMAPI I3DRenderingModule::SetKeepProportions | ( | boolean | keepProportions | ) | `[pure virtual]`

Sets the state of the "Keep Proportions" checkbox.

Parameters:

  | keepProportions | True if the checkbox is checked.

virtual MCCOMErr MCCOMAPI I3DRenderingModule::SetMovieFileTypeID | ( | IDType | fileTypeID | ) | `[pure virtual]`

Sets the file format of the movie that is rendered.

Parameters:

  | fileTypeID | The file format of the movie that is rendered.

virtual MCCOMErr MCCOMAPI I3DRenderingModule::SetOutputFileName | ( | const TMCString & | fileName | ) | `[pure virtual]`

Sets the pathname of the output image file.

Parameters:

  | fileName | The pathname of the output image file.

virtual MCCOMErr MCCOMAPI I3DRenderingModule::SetOutputOption | ( | int32 | option | ) | `[pure virtual]`

Sets the output status.

Parameters:

  | option | The output status: 1 save in default location. 2 save as specified by SetOutputFileName.

virtual void MCCOMAPI I3DRenderingModule::SetPixelAspectRatio | ( | real | pixelAspectRatio | ) | `[pure virtual]`

Sets the pixel aspect ration.

Parameters:

  | pixelAspectRatio | The pixel aspect ratio.

virtual MCCOMErr MCCOMAPI I3DRenderingModule::SetPixelSize | ( | uint32 | width,
|  | uint32 | height |
| ) |  |  | `[pure virtual]`

Sets the size of the rendered image in pixels.

Parameters:

  | width | Width of the image in pixels.
  | height | Height of the image in pixels.

virtual MCCOMErr MCCOMAPI I3DRenderingModule::SetRenderer | ( | I3DExFinalRenderer * | renderer | ) | `[pure virtual]`

Sets the current final renderer.

Parameters:

  | renderer | A pointer to the new final renderer

virtual void MCCOMAPI I3DRenderingModule::SetRenderingCamera | ( | I3DShCamera * | camera | ) | `[pure virtual]`

Sets the rendering camera.

Parameters:

  | camera | A pointer to the rendering camera.

virtual void MCCOMAPI I3DRenderingModule::SetRenderingCameraByName | ( | const TMCString & | cameraName | ) | `[pure virtual]`

Sets the rendering camera.

Parameters:

  | cameraName | The name of the rendering camera.

virtual void MCCOMAPI I3DRenderingModule::SetRenderMovie | ( | boolean | renderMovie | ) | `[pure virtual]`

Specifies whether the render should render a movie (by opposition to the current frame).

Parameters:

  | renderMovie | True if a movie should be rendered.

virtual MCCOMErr MCCOMAPI I3DRenderingModule::SetSize | ( | real | width,
|  | real | height,
|  | real | dpi |
| ) |  |  | `[pure virtual]`

Sets the size of the rendering. To calculate the size in pixels, use the following code:

     pixelH = width * dpi / 72;
     pixelV = height * dpi / 72;

Parameters:

  | width | Width of the image.
  | height | Height of the image.
  | dpi | Pixels per inch.

The documentation for this struct was generated from the following file:

- I3DRenderingModule.h